'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = middlewareCreate;
function middlewareCreate(api) {
  for (var _len = arguments.length, rest = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    rest[_key - 1] = arguments[_key];
  }

  return function (store) {
    return function (next) {
      return function (action) {
        if (typeof action === 'function') {
          return action.apply(undefined, [api, store.dispatch, store.getState].concat(rest));
        }
        return next(action);
      };
    };
  };
}