'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.default = manufactureReducer;

var _immutable = require('immutable');

var _immutableReducers = require('./immutableReducers');

var _immutableReducers2 = _interopRequireDefault(_immutableReducers);

var _redux = require('redux');

var _forIn = require('lodash/forIn');

var _forIn2 = _interopRequireDefault(_forIn);

var _GeneralConstants = require('./GeneralConstants');

var _GeneralConstants2 = _interopRequireDefault(_GeneralConstants);

var _wrappedState = require('./wrappedState');

var _wrappedState2 = _interopRequireDefault(_wrappedState);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function handlePossibleImmutable(object) {
  if (!object) return [object];
  if (object.toJS) return ['IMMUTABLE', object.toJS()];
  return [object];
}

function manufactureReducer(tree) {
  var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var _ref$hearGeneral = _ref.hearGeneral;
  var hearGeneral = _ref$hearGeneral === undefined ? false : _ref$hearGeneral;
  var _ref$asImmutable = _ref.asImmutable;
  var asImmutable = _ref$asImmutable === undefined ? true : _ref$asImmutable;
  var _ref$strictMode = _ref.strictMode;
  var strictMode = _ref$strictMode === undefined ? false : _ref$strictMode;
  var _ref$logging = _ref.logging;
  var logging = _ref$logging === undefined ? false : _ref$logging;
  var _ref$resetAction = _ref.resetAction;
  var resetAction = _ref$resetAction === undefined ? [] : _ref$resetAction;

  var reducers = asImmutable ? new _immutable.Map({}) : {};

  if (!Array.isArray(resetAction)) {
    resetAction = [resetAction];
  }

  resetAction = resetAction.map(function (x) {
    return x.trim();
  });

  if (strictMode) {
    (0, _forIn2.default)(tree, function (value, key) {
      var innerMethods = value[1];
      (0, _keys2.default)(innerMethods).forEach(function (constantPassed) {
        if (constantPassed.indexOf('DONE') === -1 && constantPassed.indexOf('FAILED') === -1 && constantPassed.indexOf('STARTING') === -1 && !_GeneralConstants2.default[constantPassed] && strictMode) {
          var warn = console.warn;
          warn('Constant in reducer w/o DONE/FAILED/STARTING: ' + constantPassed + ' on key ' + key);
          warn('To suppress this warning, turn off strictMode');
        }
        return constantPassed;
      });
    });
  }

  (0, _forIn2.default)(tree, function (value, key) {
    var _value = (0, _slicedToArray3.default)(value, 2);

    var defaultState = _value[0];
    var innerMethods = _value[1];


    var method = function method() {
      var prevState = arguments.length <= 0 || arguments[0] === undefined ? defaultState : arguments[0];
      var _ref2 = arguments[1];
      var type = _ref2.type;
      var rest = (0, _objectWithoutProperties3.default)(_ref2, ['type']);

      if (type === _GeneralConstants2.default.ACTION_CALLED && !hearGeneral) return prevState;

      if (resetAction.indexOf(type.trim()) !== -1) {
        return defaultState;
      }

      // NB: The way we do constant matching could be done better
      return (0, _keys2.default)(innerMethods).reduce(function (prev, matchingConstants) {
        var response = innerMethods[matchingConstants];
        var doesMatch = matchingConstants.trim().split(' ').some(function (x) {
          return x === type.trim();
        });

        if (!doesMatch) return prev;

        if (logging) {
          var _console;

          var styles = 'background: blue; color: white; font-size: 14px';
          console.log(' ');
          console.log('%c ----', 'color: blue');
          console.log('%c "' + key + '": ' + matchingConstants, styles);
          console.log(rest);
          (_console = console).log.apply(_console, ['Starting as: '].concat((0, _toConsumableArray3.default)(handlePossibleImmutable(prevState))));
        }

        var stateObj = strictMode || logging ? (0, _wrappedState2.default)(prevState, { key: key, strictMode: strictMode, logging: logging }) : prevState;

        var resp = typeof response === 'function' ? response(rest, stateObj) : response;

        if (logging) {
          var _console2;

          (_console2 = console).log.apply(_console2, ['Ending as: '].concat((0, _toConsumableArray3.default)(handlePossibleImmutable(resp))));
          console.log('%c ----', 'color: blue');
          console.log(' ');
        }

        return resp;
      }, prevState);
    };

    reducers = asImmutable ? reducers.set(key, method) : (0, _extends4.default)({}, reducers, (0, _defineProperty3.default)({}, key, method));
  });

  return asImmutable ? (0, _immutableReducers2.default)(reducers, { strictMode: strictMode, logging: logging }) : (0, _redux.combineReducers)(reducers);
}