'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _createReducer = require('./createReducer');

var _createReducer2 = _interopRequireDefault(_createReducer);

var _immutable = require('immutable');

var _GeneralConstants = require('./GeneralConstants');

var _GeneralConstants2 = _interopRequireDefault(_GeneralConstants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref9, _ref12, _ref15;

  var opts = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  return (0, _createReducer2.default)({
    lastCalled: [new _immutable.Map({}), (0, _defineProperty3.default)({}, _GeneralConstants2.default.ACTION_CALLED, function (_ref, prevState) {
      var action = _ref.action;
      return prevState.set(action, Date.now());
    })],
    lastSucceeded: [new _immutable.Map({}), (0, _defineProperty3.default)({}, _GeneralConstants2.default.ACTION_SUCCEEDED, function (_ref3, prevState) {
      var action = _ref3.action;
      return prevState.set(action, Date.now());
    })],
    monitorValues: [new _immutable.Map({}), (0, _defineProperty3.default)({}, _GeneralConstants2.default.MONITORED_VALUE_CHANGED, function (_ref5, prevState) {
      var id = _ref5.id;
      var props = _ref5.props;
      var state = _ref5.state;
      return prevState.set(id, (0, _immutable.fromJS)({
        props: props,
        state: state
      }));
    })],
    pending: [new _immutable.Map({}), (_ref9 = {}, (0, _defineProperty3.default)(_ref9, _GeneralConstants2.default.ACTION_CALLED, function (_ref7, prevState) {
      var cycleId = _ref7.cycleId;

      if (!cycleId) return prevState;
      return prevState.set(cycleId, true);
    }), (0, _defineProperty3.default)(_ref9, _GeneralConstants2.default.ACTION_SUCCEEDED + ' ' + _GeneralConstants2.default.ACTION_FAILED, function (_ref8, prevState) {
      var cycleId = _ref8.cycleId;

      if (!cycleId) return prevState;
      return prevState.set(cycleId, false);
    }), _ref9)],
    failed: [new _immutable.Map({}), (_ref12 = {}, (0, _defineProperty3.default)(_ref12, _GeneralConstants2.default.ACTION_CALLED + ' ' + _GeneralConstants2.default.ACTION_SUCCEEDED, function (_ref10, prevState) {
      var cycleId = _ref10.cycleId;

      if (!cycleId) return prevState;
      return prevState.set(cycleId, null);
    }), (0, _defineProperty3.default)(_ref12, _GeneralConstants2.default.ACTION_FAILED, function (_ref11, prevState) {
      var cycleId = _ref11.cycleId;
      var rest = (0, _objectWithoutProperties3.default)(_ref11, ['cycleId']);

      if (!cycleId) return prevState;
      return prevState.set(cycleId, opts.errorParser ? opts.errorParser((0, _extends3.default)({ cycleId: cycleId }, rest)) : true);
    }), _ref12)],
    highlightedComponents: [new _immutable.Map({}), (_ref15 = {}, (0, _defineProperty3.default)(_ref15, _GeneralConstants2.default.HIGHLIGHT_COMPONENT, function (_ref13, state) {
      var id = _ref13.id;
      var color = _ref13.color;
      return state.set(id, color);
    }), (0, _defineProperty3.default)(_ref15, _GeneralConstants2.default.UNHIGHLIGHT_COMPONENT, function (_ref14, state) {
      var id = _ref14.id;
      return state.delete(id);
    }), _ref15)]
  }, (0, _extends3.default)({}, opts, { hearGeneral: true }));
};